/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: tool_svc.h 6837 2013-01-23 10:46:48Z fsi-dankei $
 */

/*  This file is generated from svc.def by gensvc_atk. */

#ifndef TOPPERS_TOOL_SVC_H
#define TOPPERS_TOOL_SVC_H

#define SVC_TRAP(system_service) _trap_ ## system_service

#ifndef TOPPERS_SVC_FUNCCALL
#define StartOS _trap_StartOS
#define ShutdownOS _trap_ShutdownOS
#define ActivateTask _trap_ActivateTask
#define TerminateTask _trap_TerminateTask
#define ChainTask _trap_ChainTask
#define Schedule _trap_Schedule
#define GetTaskID _trap_GetTaskID
#define GetTaskState _trap_GetTaskState
#define EnableAllInterrupts _trap_EnableAllInterrupts
#define DisableAllInterrupts _trap_DisableAllInterrupts
#define ResumeAllInterrupts _trap_ResumeAllInterrupts
#define SuspendAllInterrupts _trap_SuspendAllInterrupts
#define ResumeOSInterrupts _trap_ResumeOSInterrupts
#define SuspendOSInterrupts _trap_SuspendOSInterrupts
#define GetISRID _trap_GetISRID
#define DisableInterruptSource _trap_DisableInterruptSource
#define EnableInterruptSource _trap_EnableInterruptSource
#define GetResource _trap_GetResource
#define ReleaseResource _trap_ReleaseResource
#define SetEvent _trap_SetEvent
#define ClearEvent _trap_ClearEvent
#define GetEvent _trap_GetEvent
#define WaitEvent _trap_WaitEvent
#define GetAlarmBase _trap_GetAlarmBase
#define GetAlarm _trap_GetAlarm
#define SetRelAlarm _trap_SetRelAlarm
#define SetAbsAlarm _trap_SetAbsAlarm
#define CancelAlarm _trap_CancelAlarm
#define IncrementCounter _trap_IncrementCounter
#define GetCounterValue _trap_GetCounterValue
#define GetElapsedValue _trap_GetElapsedValue
#define CheckISRMemoryAccess _trap_CheckISRMemoryAccess
#define CheckTaskMemoryAccess _trap_CheckTaskMemoryAccess
#define CheckTaskAccess _trap_CheckTaskAccess
#define CheckISRAccess _trap_CheckISRAccess
#define CheckAlarmAccess _trap_CheckAlarmAccess
#define CheckResourceAccess _trap_CheckResourceAccess
#define CheckCounterAccess _trap_CheckCounterAccess
#define CheckScheduleTableAccess _trap_CheckScheduleTableAccess
#define CheckTaskOwnership _trap_CheckTaskOwnership
#define CheckISROwnership _trap_CheckISROwnership
#define CheckAlarmOwnership _trap_CheckAlarmOwnership
#define CheckCounterOwnership _trap_CheckCounterOwnership
#define CheckScheduleTableOwnership _trap_CheckScheduleTableOwnership
#define GetApplicationID _trap_GetApplicationID
#define CallTrustedFunction _trap_CallTrustedFunction
#define GetApplicationState _trap_GetApplicationState
#define GetActiveApplicationMode _trap_GetActiveApplicationMode
#define StartScheduleTableRel _trap_StartScheduleTableRel
#define StartScheduleTableAbs _trap_StartScheduleTableAbs
#define StopScheduleTable _trap_StopScheduleTable
#define NextScheduleTable _trap_NextScheduleTable
#define GetScheduleTableStatus _trap_GetScheduleTableStatus
#define GetFaultyContext _trap_GetFaultyContext
#endif

#ifndef TOPPERS_MACRO_ONLY

LOCAL_INLINE void
_trap_StartOS(AppModeType Mode)
{
	CAL_SVC_1N(void, TFN_STARTOS, AppModeType, Mode);
}

LOCAL_INLINE void
_trap_ShutdownOS(StatusType Error)
{
	CAL_SVC_1N(void, TFN_SHUTDOWNOS, StatusType, Error);
}

LOCAL_INLINE StatusType
_trap_ActivateTask(TaskType TaskID)
{
	CAL_SVC_1M(StatusType, TFN_ACTIVATETASK, TaskType, TaskID);
}

LOCAL_INLINE StatusType
_trap_TerminateTask(void)
{
	CAL_SVC_0M(StatusType, TFN_TERMINATETASK);
}

LOCAL_INLINE StatusType
_trap_ChainTask(TaskType TaskID)
{
	CAL_SVC_1M(StatusType, TFN_CHAINTASK, TaskType, TaskID);
}

LOCAL_INLINE StatusType
_trap_Schedule(void)
{
	CAL_SVC_0M(StatusType, TFN_SCHEDULE);
}

LOCAL_INLINE StatusType
_trap_GetTaskID(TaskRefType TaskID)
{
	CAL_SVC_1M(StatusType, TFN_GETTASKID, TaskRefType, TaskID);
}

LOCAL_INLINE StatusType
_trap_GetTaskState(TaskType TaskID, TaskStateRefType State)
{
	CAL_SVC_2M(StatusType, TFN_GETTASKSTATE, TaskType, TaskID, TaskStateRefType, State);
}

LOCAL_INLINE void
_trap_EnableAllInterrupts(void)
{
	CAL_SVC_0N(void, TFN_ENABLEALLINTERRUPTS);
}

LOCAL_INLINE void
_trap_DisableAllInterrupts(void)
{
	CAL_SVC_0N(void, TFN_DISABLEALLINTERRUPTS);
}

LOCAL_INLINE void
_trap_ResumeAllInterrupts(void)
{
	CAL_SVC_0N(void, TFN_RESUMEALLINTERRUPTS);
}

LOCAL_INLINE void
_trap_SuspendAllInterrupts(void)
{
	CAL_SVC_0N(void, TFN_SUSPENDALLINTERRUPTS);
}

LOCAL_INLINE void
_trap_ResumeOSInterrupts(void)
{
	CAL_SVC_0N(void, TFN_RESUMEOSINTERRUPTS);
}

LOCAL_INLINE void
_trap_SuspendOSInterrupts(void)
{
	CAL_SVC_0N(void, TFN_SUSPENDOSINTERRUPTS);
}

LOCAL_INLINE ISRType
_trap_GetISRID(void)
{
	CAL_SVC_0M(ISRType, TFN_GETISRID);
}

LOCAL_INLINE StatusType
_trap_DisableInterruptSource(ISRType DisableISR)
{
	CAL_SVC_1M(StatusType, TFN_DISABLEINTERRUPTSOURCE, ISRType, DisableISR);
}

LOCAL_INLINE StatusType
_trap_EnableInterruptSource(ISRType EnableISR)
{
	CAL_SVC_1M(StatusType, TFN_ENABLEINTERRUPTSOURCE, ISRType, EnableISR);
}

LOCAL_INLINE StatusType
_trap_GetResource(ResourceType ResID)
{
	CAL_SVC_1M(StatusType, TFN_GETRESOURCE, ResourceType, ResID);
}

LOCAL_INLINE StatusType
_trap_ReleaseResource(ResourceType ResID)
{
	CAL_SVC_1M(StatusType, TFN_RELEASERESOURCE, ResourceType, ResID);
}

LOCAL_INLINE StatusType
_trap_SetEvent(TaskType TaskID, EventMaskType Mask)
{
	CAL_SVC_2M(StatusType, TFN_SETEVENT, TaskType, TaskID, EventMaskType, Mask);
}

LOCAL_INLINE StatusType
_trap_ClearEvent(EventMaskType Mask)
{
	CAL_SVC_1M(StatusType, TFN_CLEAREVENT, EventMaskType, Mask);
}

LOCAL_INLINE StatusType
_trap_GetEvent(TaskType TaskID, EventMaskRefType Event)
{
	CAL_SVC_2M(StatusType, TFN_GETEVENT, TaskType, TaskID, EventMaskRefType, Event);
}

LOCAL_INLINE StatusType
_trap_WaitEvent(EventMaskType Mask)
{
	CAL_SVC_1M(StatusType, TFN_WAITEVENT, EventMaskType, Mask);
}

LOCAL_INLINE StatusType
_trap_GetAlarmBase(AlarmType AlarmID, AlarmBaseRefType Info)
{
	CAL_SVC_2M(StatusType, TFN_GETALARMBASE, AlarmType, AlarmID, AlarmBaseRefType, Info);
}

LOCAL_INLINE StatusType
_trap_GetAlarm(AlarmType AlarmID, TickRefType Tick)
{
	CAL_SVC_2M(StatusType, TFN_GETALARM, AlarmType, AlarmID, TickRefType, Tick);
}

LOCAL_INLINE StatusType
_trap_SetRelAlarm(AlarmType AlarmID, TickType increment, TickType cycle)
{
	CAL_SVC_3M(StatusType, TFN_SETRELALARM, AlarmType, AlarmID, TickType, increment, TickType, cycle);
}

LOCAL_INLINE StatusType
_trap_SetAbsAlarm(AlarmType AlarmID, TickType start, TickType cycle)
{
	CAL_SVC_3M(StatusType, TFN_SETABSALARM, AlarmType, AlarmID, TickType, start, TickType, cycle);
}

LOCAL_INLINE StatusType
_trap_CancelAlarm(AlarmType AlarmID)
{
	CAL_SVC_1M(StatusType, TFN_CANCELALARM, AlarmType, AlarmID);
}

LOCAL_INLINE StatusType
_trap_IncrementCounter(CounterType CounterID)
{
	CAL_SVC_1M(StatusType, TFN_INCREMENTCOUNTER, CounterType, CounterID);
}

LOCAL_INLINE StatusType
_trap_GetCounterValue(CounterType CounterID, TickRefType Value)
{
	CAL_SVC_2M(StatusType, TFN_GETCOUNTERVALUE, CounterType, CounterID, TickRefType, Value);
}

LOCAL_INLINE StatusType
_trap_GetElapsedValue(CounterType CounterID, TickRefType Value, TickRefType ElapsedValue)
{
	CAL_SVC_3M(StatusType, TFN_GETELAPSEDVALUE, CounterType, CounterID, TickRefType, Value, TickRefType, ElapsedValue);
}

LOCAL_INLINE AccessType
_trap_CheckISRMemoryAccess(ISRType ISRID, MemoryStartAddressType Address, MemorySizeType Size)
{
	CAL_SVC_3M(AccessType, TFN_CHECKISRMEMORYACCESS, ISRType, ISRID, MemoryStartAddressType, Address, MemorySizeType, Size);
}

LOCAL_INLINE AccessType
_trap_CheckTaskMemoryAccess(TaskType TaskID, MemoryStartAddressType Address, MemorySizeType Size)
{
	CAL_SVC_3M(AccessType, TFN_CHECKTASKMEMORYACCESS, TaskType, TaskID, MemoryStartAddressType, Address, MemorySizeType, Size);
}

LOCAL_INLINE ObjectAccessType
_trap_CheckTaskAccess(ApplicationType ApplID, TaskType TaskID)
{
	CAL_SVC_2M(ObjectAccessType, TFN_CHECKTASKACCESS, ApplicationType, ApplID, TaskType, TaskID);
}

LOCAL_INLINE ObjectAccessType
_trap_CheckISRAccess(ApplicationType ApplID, ISRType ISRID)
{
	CAL_SVC_2M(ObjectAccessType, TFN_CHECKISRACCESS, ApplicationType, ApplID, ISRType, ISRID);
}

LOCAL_INLINE ObjectAccessType
_trap_CheckAlarmAccess(ApplicationType ApplID, AlarmType AlarmID)
{
	CAL_SVC_2M(ObjectAccessType, TFN_CHECKALARMACCESS, ApplicationType, ApplID, AlarmType, AlarmID);
}

LOCAL_INLINE ObjectAccessType
_trap_CheckResourceAccess(ApplicationType ApplID, ResourceType ResID)
{
	CAL_SVC_2M(ObjectAccessType, TFN_CHECKRESOURCEACCESS, ApplicationType, ApplID, ResourceType, ResID);
}

LOCAL_INLINE ObjectAccessType
_trap_CheckCounterAccess(ApplicationType ApplID, CounterType CounterID)
{
	CAL_SVC_2M(ObjectAccessType, TFN_CHECKCOUNTERACCESS, ApplicationType, ApplID, CounterType, CounterID);
}

LOCAL_INLINE ObjectAccessType
_trap_CheckScheduleTableAccess(ApplicationType ApplID, ScheduleTableType ScheduleTableID)
{
	CAL_SVC_2M(ObjectAccessType, TFN_CHECKSCHEDULETABLEACCESS, ApplicationType, ApplID, ScheduleTableType, ScheduleTableID);
}

LOCAL_INLINE ApplicationType
_trap_CheckTaskOwnership(TaskType TaskID)
{
	CAL_SVC_1M(ApplicationType, TFN_CHECKTASKOWNERSHIP, TaskType, TaskID);
}

LOCAL_INLINE ApplicationType
_trap_CheckISROwnership(ISRType ISRID)
{
	CAL_SVC_1M(ApplicationType, TFN_CHECKISROWNERSHIP, ISRType, ISRID);
}

LOCAL_INLINE ApplicationType
_trap_CheckAlarmOwnership(AlarmType AlarmID)
{
	CAL_SVC_1M(ApplicationType, TFN_CHECKALARMOWNERSHIP, AlarmType, AlarmID);
}

LOCAL_INLINE ApplicationType
_trap_CheckCounterOwnership(CounterType CounterID)
{
	CAL_SVC_1M(ApplicationType, TFN_CHECKCOUNTEROWNERSHIP, CounterType, CounterID);
}

LOCAL_INLINE ApplicationType
_trap_CheckScheduleTableOwnership(ScheduleTableType ScheduleTableID)
{
	CAL_SVC_1M(ApplicationType, TFN_CHECKSCHEDULETABLEOWNERSHIP, ScheduleTableType, ScheduleTableID);
}

LOCAL_INLINE ApplicationType
_trap_GetApplicationID(void)
{
	CAL_SVC_0M(ApplicationType, TFN_GETAPPLICATIONID);
}

LOCAL_INLINE StatusType
_trap_CallTrustedFunction(TrustedFunctionIndexType FunctionIndex, TrustedFunctionParameterRefType FunctionParams)
{
	CAL_SVC_2M(StatusType, TFN_CALLTRUSTEDFUNCTION, TrustedFunctionIndexType, FunctionIndex, TrustedFunctionParameterRefType, FunctionParams);
}

LOCAL_INLINE StatusType
_trap_GetApplicationState(ApplicationType Application, ApplicationStateRefType Value)
{
	CAL_SVC_2M(StatusType, TFN_GETAPPLICATIONSTATE, ApplicationType, Application, ApplicationStateRefType, Value);
}

LOCAL_INLINE AppModeType
_trap_GetActiveApplicationMode(void)
{
	CAL_SVC_0M(AppModeType, TFN_GETACTIVEAPPLICATIONMODE);
}

LOCAL_INLINE StatusType
_trap_StartScheduleTableRel(ScheduleTableType ScheduleTableID, TickType Offset)
{
	CAL_SVC_2M(StatusType, TFN_STARTSCHEDULETABLEREL, ScheduleTableType, ScheduleTableID, TickType, Offset);
}

LOCAL_INLINE StatusType
_trap_StartScheduleTableAbs(ScheduleTableType ScheduleTableID, TickType Start)
{
	CAL_SVC_2M(StatusType, TFN_STARTSCHEDULETABLEABS, ScheduleTableType, ScheduleTableID, TickType, Start);
}

LOCAL_INLINE StatusType
_trap_StopScheduleTable(ScheduleTableType ScheduleTableID)
{
	CAL_SVC_1M(StatusType, TFN_STOPSCHEDULETABLE, ScheduleTableType, ScheduleTableID);
}

LOCAL_INLINE StatusType
_trap_NextScheduleTable(ScheduleTableType ScheduleTableID_From, ScheduleTableType ScheduleTableID_To)
{
	CAL_SVC_2M(StatusType, TFN_NEXTSCHEDULETABLE, ScheduleTableType, ScheduleTableID_From, ScheduleTableType, ScheduleTableID_To);
}

LOCAL_INLINE StatusType
_trap_GetScheduleTableStatus(ScheduleTableType ScheduleTableID, ScheduleTableStatusRefType ScheduleStatus)
{
	CAL_SVC_2M(StatusType, TFN_GETSCHEDULETABLESTATUS, ScheduleTableType, ScheduleTableID, ScheduleTableStatusRefType, ScheduleStatus);
}

LOCAL_INLINE FaultyContextType
_trap_GetFaultyContext(void)
{
	CAL_SVC_0M(FaultyContextType, TFN_GETFAULTYCONTEXT);
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_TOOL_SVC_H */
