$
$  TOPPERS ATK2
$      Toyohashi Open Platform for Embedded Real-Time Systems
$      Automotive Kernel Version 2
$
$  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
$              Graduate School of Information Science, Nagoya Univ., JAPAN
$  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
$  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
$  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
$  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
$  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
$  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
$  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
$  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
$
$  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$  ܥեȥѤΤޤࡥʲƱˤѡʣ
$  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$      ˴ޤޤƤ뤳ȡ
$  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$      ѤǤǺۤˤϡۤȼɥȡ
$      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$      ̵ݾڵǺܤ뤳ȡ
$  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$      ѤǤʤǺۤˤϡΤ줫ξ
$      ȡ
$    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$        𤹤뤳ȡ
$  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$      դ뤳ȡ
$
$  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$  TOPPERSץȤϡܥեȥ˴ؤơλŪ
$  ФŬޤơʤݾڤԤʤޤܥեȥ
$  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$  Ǥʤ
$
$  $Id: kernel_check.tf 6837 2013-01-23 10:46:48Z fsi-dankei $
$

$
$  ؿƬϤΥå
$
$IF CHECK_FUNC_ALIGN || CHECK_FUNC_NONNULL$
$	// ƬϤΥ饤å
	$tinib = SYMBOL("tinib_table")$
	$FOREACH tskid TSK.ID_LIST$
		$task = PEEK(tinib + offsetof_TINIB_task, sizeof_FunctionRefType)$
		$IF CHECK_FUNC_ALIGN && (task & (CHECK_FUNC_ALIGN - 1)) != 0$
			$ERROR TSK.TEXT_LINE[tskid]$
				$FORMAT(_("%1% of %2% in `%3%\' is not aligned"),
				"task", "TINIB", tskid)$$END$
		$END$
$		// ƬϤNULLå
		$IF CHECK_FUNC_NONNULL && task == 0$
			$ERROR TSK.TEXT_LINE[tskid]$
				$FORMAT(_("%1% of %2% in `%3%\' is null"),
				"task", "TINIB", tskid)$$END$
		$END$
		$tinib = tinib + sizeof_TINIB$
	$END$

$	//ϡɥ󥿤νؿ
	$HWCNTFUNC_VALID = { VALUE("init",0),VALUE("start",1),VALUE("stop",2),VALUE("set",3),VALUE("get",4),
	VALUE("cancel",5),VALUE("trigger",6),VALUE("intclear",7),VALUE("intcancel",8),VALUE("increment",9) }$

$	// ϡɥ󥿤νؿΥ饤å
	$hwcntinib = SYMBOL("hwcntinib_table")$
	$FOREACH hwcntid HWCNT.ID_LIST$
		$FOREACH memberid HWCNTFUNC_VALID$
			$offsetofmember = offsetof_HWCNTINIB_init + (sizeof_FunctionRefType * memberid)$
			$hwfunc = PEEK(hwcntinib + offsetofmember, sizeof_FunctionRefType)$
			$IF CHECK_FUNC_ALIGN && (hwfunc & (CHECK_FUNC_ALIGN - 1)) != 0$
				$ERROR HWCNT.TEXT_LINE[hwcntid]$
					$FORMAT(_("%1% of %2% in `%3%\' is not aligned"),
					memberid, "HWCNTINIB", hwcntid)$$END$
			$END$
$			// ϡɥ󥿤νؿNULLå
			$IF CHECK_FUNC_NONNULL && hwfunc == 0$
				$ERROR HWCNT.TEXT_LINE[hwcntid]$
					$FORMAT(_("%1% of %2% in `%3%\' is null"),
					memberid, "HWCNTINIB", hwcntid)$$END$
			$END$
		$END$
		$hwcntinib = hwcntinib + sizeof_HWCNTINIB$
	$END$
$END$

$
$  åΰƬϤΥå
$
$IF CHECK_STACK_ALIGN || CHECK_STACK_NONNULL$
	$tinib = SYMBOL("tinib_table")$
	$FOREACH tskid TSK.ID_LIST$
$		// ΥƥॹåΰƬϤΥå
		$IF USE_TSKINICTXB$
			$sstk = GET_SSTK_TSKINICTXB(tinib)$
		$ELSE$
			$sstk = PEEK(tinib + offsetof_TINIB_sstk, sizeof_void_ptr)$
		$END$
		$IF CHECK_STACK_ALIGN && (sstk & (CHECK_STACK_ALIGN - 1)) != 0$
			$IF OSAP.TRUSTED[TSK.OSAPID[tskid]]$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("%1% `%2%\' of `%3%\' is not aligned"),
					"stk", TSK.STK[tskid], tskid)$$END$
			$ELSE$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("%1% `%2%\' of `%3%\' is not aligned"),
					"sstk", TSK.SSTK[tskid], tskid)$$END$
			$END$
		$END$
		$IF CHECK_STACK_NONNULL && sstk == 0$
			$IF OSAP.TRUSTED[TSK.OSAPID[tskid]]$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("%1% `%2%\' of `%3%\' is null"),
					"stk", TSK.STK[tskid], tskid)$$END$
			$ELSE$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("%1% `%2%\' of `%3%\' is null"),
					"sstk", TSK.SSTK[tskid], tskid)$$END$
			$END$
		$END$

$		// Υ桼åΰƬϤΥå
		$IF !OSAP.TRUSTED[TSK.OSAPID[tskid]]$
			$IF USE_TSKINICTXB$
				$ustk = GET_USTK_TSKINICTXB(tinib)$
			$ELSE$
				$ustk = PEEK(tinib + offsetof_TINIB_ustk, sizeof_void_ptr)$
			$END$
			$IF CHECK_USTACK_ALIGN && (ustk & (CHECK_USTACK_ALIGN - 1)) != 0$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("%1% `%2%\' of `%3%\' is not aligned"),
					"stk", TSK.STK[tskid], tskid)$$END$
			$END$
			$IF CHECK_USTACK_NONNULL && ustk == 0$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("%1% `%2%\' of `%3%\' is null"),
					"stk", TSK.STK[tskid], tskid)$$END$
			$END$
		$END$
		$tinib = tinib + sizeof_TINIB$
	$END$

$	// 󥿥ƥѤΥåΰƬϤΥå
	$ostk_addr = PEEK(SYMBOL("_ostk"), sizeof_void_ptr)$
	$IF CHECK_STACK_ALIGN && (ostk_addr & (CHECK_STACK_ALIGN - 1)) != 0$
		$ERROR OSTK.TEXT_LINE[1]$
			$FORMAT(_("%1% `%2%\' is not aligned"),
			"stk", OSTK.STK[1])$$END$
	$END$
	$IF CHECK_STACK_NONNULL && ostk_addr == 0$
		$ERROR OSTK.TEXT_LINE[1]$
			$FORMAT(_("%1% `%2%\' is null"),
			"stk", OSTK.STK[1])$$END$
	$END$

$	// OSAPեå롼ѤΥåΰƬϤΥå
	$IF USE_NONTRUST_HOOK$
		$IF LENGTH(NTHSTK.STK[1]) && !EQ(NTHSTK.STK[1], "NULL")$
			$nthstk_addr = PEEK(SYMBOL("_nthkstk"), sizeof_void_ptr)$
			$IF CHECK_USTACK_ALIGN && (nthstk_addr & (CHECK_USTACK_ALIGN - 1)) != 0$
				$ERROR NTHSTK.TEXT_LINE[1]$
					$FORMAT(_("%1% `%2%\' is not aligned %3%"),
					"NonTrustedHookStack", NTHSTK.STK[1], +CHECK_USTACK_ALIGN)$$END$
			$END$

			$IF CHECK_STACK_NONNULL && nthstk_addr == 0$
				$ERROR NTHSTK.TEXT_LINE[1]$
					$FORMAT(_("%1% `%2%\' is null"),
					"NonTrustedHookStack", NTHSTK.STK[1])$$END$
			$END$
		$END$
	$END$
$END$

$tfinib_table = SYMBOL("tfinib_table")$
$FOREACH tfnid TFN.ID_LIST$
	$TrustedFunction = PEEK(tfinib_table, sizeof_TrustedFunctionRefType)$
$	// ؿƬϤΥ饤å
	$IF CHECK_FUNC_ALIGN && (task & (CHECK_FUNC_ALIGN - 1)) != 0$
		$ERROR TFN.TEXT_LINE[tfnid]$
			$FORMAT(_("%1% of %2% in `%3%\' is not aligned"),
			"trs_func", "TFINIB", TFN.TFN[tfnid])$$END$
	$END$
$	// ؿNULLå
	$IF TrustedFunction == 0$
		$ERROR TFN.TEXT_LINE[tfnid]$
			$FORMAT(_("%1% of %2% in `%2%\' is null"),
			"trs_func", "TFINIB", TFN.TFN[tfnid])$$END$
	$END$
	$tfinib_table = tfinib_table + sizeof_TFINIB$
$END$
