$
$  TOPPERS ATK2
$      Toyohashi Open Platform for Embedded Real-Time Systems
$      Automotive Kernel Version 2
$
$  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
$              Graduate School of Information Science, Nagoya Univ., JAPAN
$  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
$  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
$  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
$  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
$  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
$  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
$  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
$  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
$
$  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$  ܥեȥѤΤޤࡥʲƱˤѡʣ
$  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$      ˴ޤޤƤ뤳ȡ
$  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$      ѤǤǺۤˤϡۤȼɥȡ
$      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$      ̵ݾڵǺܤ뤳ȡ
$  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$      ѤǤʤǺۤˤϡΤ줫ξ
$      ȡ
$    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$        𤹤뤳ȡ
$  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$      դ뤳ȡ
$
$  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$  TOPPERSץȤϡܥեȥ˴ؤơλŪ
$  ФŬޤơʤݾڤԤʤޤܥեȥ
$  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$  Ǥʤ
$
$  $Id: kernel_mem2.tf 7284 2013-03-29 06:18:22Z fujitsu-wada $
$

$CFG_PASS4 = 1$
$
$  ѥ2ξɹ
$
$INCLUDE "cfg2_out.tf"$
$INCLUDE "kernel/kernel_common.tf"$


$FILE "kernel_mem.c"$
/* kernel_mem.c */$NL$
#include "kernel/kernel_int.h"$NL$
#include "Os_Lcfg.h"$NL$
#include "kernel_mem.h"$NL$
#ifndef TOPPERS_EMPTY_LABEL$NL$
#define TOPPERS_EMPTY_LABEL(x, y) x y[0]$NL$
#endif$NL$
$NL$

/*$NL$
$SPC$*  Include Directives (#include)$NL$
$SPC$*/$NL$
$NL$
$INCLUDES$
$NL$

$
$  ꥪ֥ȤΥå
$
$FUNCTION CHECK_MO_ADDR$
	$FOREACH moid MO_SECTION_LIST$
		$IF MO.BASEADDR[moid] > MO.LIMITADDR[moid] && MO.LIMITADDR[moid] != 0$
			$IF MO.TYPE[moid] == TOPPERS_ATTMEM$
				$ERROR MO.TEXT_LINE[moid]$
					$FORMAT(_("%1% `%2%\' is too large"),
								"size", MO.SIZE[moid])$
				$END$
			$ELSE$
				$ERROR MO.TEXT_LINE[moid]$
					$FORMAT(_("illegal memory object size"))$
				$END$
			$END$
		$END$
	$END$
$END$

$
$  ꥪ֥ȤνŤʤå
$
$FUNCTION CHECK_MO_OVERLAP$
	$prev = 0$
	$FOREACH moid SORT(MO_SECTION_LIST, "MO.BASEADDR")$
		$IF MO.BASEADDR[moid] != MO.LIMITADDR[moid]$
			$IF !prev || (MO.LIMITADDR[prev] <= MO.BASEADDR[moid]
													&& MO.LIMITADDR[prev] != 0)$
				$prev = moid$
			$ELSE$
$				// ꥪ֥Ȥΰ˽Ťʤ꤬
				$IF !(MO.TYPE[moid] == TOPPERS_USTACK && MO.TYPE[prev] == TOPPERS_USTACK)$
$					// 顼åν
					$IF MO.TYPE[moid] == TOPPERS_ATTMEM$
						$ERROR MO.TEXT_LINE[moid]$
							$FORMAT(_("memory object overlaps with another memory object"))$
						$END$
					$ELIF MO.TYPE[prev] == TOPPERS_ATTMEM$
						$ERROR MO.TEXT_LINE[prev]$
							$FORMAT(_("memory object overlaps with another memory object"))$
						$END$
					$ELIF MO.TYPE[moid] == TOPPERS_USTACK$
						$ERROR MO.TEXT_LINE[moid]$
							$FORMAT(_("user stack area overlaps with another memory object"))$
						$END$
					$ELIF MO.TYPE[prev] == TOPPERS_USTACK$
						$ERROR MO.TEXT_LINE[prev]$
							$FORMAT(_("user stack area overlaps with another memory object"))$
						$END$
					$ELSE$
						$ERROR MO.TEXT_LINE[moid]$
							$FORMAT(_("memory objects overlap"))$
						$END$
					$END$
				$END$
			$END$
		$END$
	$END$
$END$

$
$  ΰޤꥪ֥ȤΥ
$
$FUNCTION SEARCH_MO$
	$_base = ARGV[1]$
	$_limit = (ARGV[1] + ARGV[2]) & ((1 << sizeof_void_ptr * 8) - 1)$
	$IF _limit < _base && _limit != 0$
		$RESULT = 0$
	$ELSE$
		$i = 1$
		$j = LENGTH(MO_MEMTOP_ORDER)$
		$found = 0$

		$WHILE !found && i <= j$
			$k = (i + j) / 2$
			$_moid = AT(MO_MEMTOP_ORDER,k-1)$
			$IF _base < MO.BASEADDR[_moid]$
				$j = k - 1$
			$ELIF _base >= MO.LIMITADDR[_moid] && MO.LIMITADDR[_moid] != 0$
				$i = k + 1$
			$ELSE$
				$found = _moid$
			$END$
		$END$
		$IF found && _limit > MO.LIMITADDR[found] && MO.LIMITADDR[found] != 0$
			$found = 0$
		$END$
		$RESULT = found$
	$END$
$END$

$
$  ΰ褬ͥѤΥꥪ֥Ȥ˴ޤޤƤ뤫Υå
$
$FUNCTION CHECK_MEMOBJ_KERNEL$
	$moid = SEARCH_MO(ARGV[1], ARGV[2])$
	$IF moid && MO.ACPTN_R[moid] == TACP_KERNEL
			 && MO.ACPTN_W[moid] == TACP_KERNEL
			 && MO.ACPTN_X[moid] == TACP_KERNEL$
		$RESULT = 0$
	$ELSE$
		$RESULT = 1$
	$END$
$END$

$ MO.BASEADDR, MO.LIMITADDR
$SET_MO_ADDR()$

$ MO_MEMTOP_ORDER_MEMINIBκ
$SET_MEMTOP_ORDER()$

$ MO_MEMTOP_ORDER_MEMINIB
$MERGE_MEMINIB()$

$tnum_meminib = PEEK(SYMBOL("tnum_meminib"), sizeof_void_ptr)$

$IF !OMIT_STANDARD_MEMINIB$
$ memtop_table, meminib_tableν
$GENERATE_MEMINIB_TABLE(tnum_meminib)$
$END$
$ ǡơ֥Ϥ(kernel_common.tf)
$GENERATE_DATASECINIB_TABLE()$

$ BSSơ֥Ϥ(kernel_common.tf)
$GENERATE_BSSSECINIB_TABLE()$

$ åȰ¸ɬפMPUINFOBϤ
$GENERATE_TARGET_MPUINFOB()$

$ ֥åϤ(kernel_common.tf)
$GENERATE_TINIB_TABLE()$

$ OSץꥱ֥åϤ(kernel_common.tf)
$GENERATE_OSAPINIB_TABLE()$


$ ꥪ֥ȤΥå
$CHECK_MO_ADDR()$

$ ꥪ֥ȤνŤʤå
$CHECK_MO_OVERLAP()$

$ MO_MEMTOP_ORDERꥪ֥ȤΥ١ɥ쥹Υꥹ
$MO_MEMTOP_ORDER = SORT(MO_SECTION_LIST, "MO.BASEADDR")$

$
$ ƥॿΥåΰȥ桼Υƥॹåΰ褬
$ ͥѤΥꥪ֥Ȥ˴ޤޤƤ뤫Υå
$
$IF !USE_TSKINICTXB$
	$tinib = SYMBOL("tinib_table")$
	$FOREACH tskid TSK.ID_LIST$
		$sstk = PEEK(tinib + offsetof_TINIB_sstk, sizeof_void_ptr)$
		$sstksz = PEEK(tinib + offsetof_TINIB_sstksz, sizeof_MemorySizeType)$
		$IF CHECK_MEMOBJ_KERNEL(sstk, sstksz)$
			$IF OSAP.TRUSTED[TSK.OSAPID[tskid]]$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("stack area of `%1%\' is not included in any kernel memory object"), tskid)$
				$END$
			$ELSE$
				$ERROR TSK.TEXT_LINE[tskid]$
					$FORMAT(_("system stack area of `%1%\' is not included in any kernel memory object"), tskid)$
				$END$
			$END$
		$END$
		$tinib = tinib + sizeof_TINIB$
	$END$
$END$

$
$ 󥿥ƥѤΥåΰ褬ͥѤΥꥪ֥
$ Ȥ˴ޤޤƤ뤫Υå
$
$ostk = PEEK(SYMBOL("_ostk"), sizeof_void_ptr)$
$ostksz = PEEK(SYMBOL("_ostksz"), sizeof_MemorySizeType)$
$IF CHECK_MEMOBJ_KERNEL(ostk, ostksz)$
	$ERROR OSTK.TEXT_LINE[1]$
		$FORMAT(_("OS stack area is not included in any kernel memory object"))$
	$END$
$END$

$FILE "kernel_mem.h"$
/* kernel_mem.h */$NL$
#ifndef TOPPERS_KERNEL_MEM_H$NL$
#define TOPPERS_KERNEL_MEM_H$NL$
/*$NL$
$SPC$*  Include Directives (#include)$NL$
$SPC$*/$NL$
$NL$
$INCLUDES$
$NL$
$NL$
$ γϡüΥ٥extern
$EXTERN_SECTION_LABEL()$

$ åΰextern(kernel_common.tf)
$GENERATE_EXPORT_TSK_STK()$

$ extern(kernel_common.tf)
$EXTERN_TSK()$

#endif /* TOPPERS_KERNEL_MEM_H */$NL$

$INCLUDE "target_check.tf"$
